//+------------------------------------------------------------------+
//|                                           MadaForex_TrendBar.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Madaforex"
#property link      ""

#property indicator_chart_window

// Pour pouvoir utiliser iCustom
extern int timeFrame = 0;
double retour[];

//int tframe[]={1,5,15,30,60,240,1440,10080,43200};
int tframe[]={/*43200,10080,1440,*/240,60,30,15/*,5,1*/};
//string tf[]={"M1","M5","M15","M30","H1","H4","D1","W1","MN1"};
string tfMACD[]={/*"MN1","W1","D1",*/"H4","H1","M30","M15"/*,"M5","M1"*/};
int tfnumber=4;    

extern string ___IndicatorSetup___=">>> Indicator Setup:<<<";
extern string MACD        = "About MACD";
extern int fastMACD         = 12;
extern int slowMACD         = 26;
extern int signalMACD   = 9;
extern int priceMACD    = 6;

extern string ___DisplaySetup___=">>> Display Setup:<<<";
extern color UpColor=Lime;
extern color DownColor=Red;
extern color FlatColor=Orange;
extern color TextColor=DimGray;
extern int Corner=3;


double MACDMAIN,MACDSIGNAL;
string TimeFrameStr;
double IndVal[9];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   for(int w=1;w<tfnumber+1;w++)
   {
      ObjectCreate(tfMACD[w-1],OBJ_LABEL,0,0,0,0,0);
      ObjectSet(tfMACD[w-1],OBJPROP_CORNER,Corner);
      ObjectSet(tfMACD[w-1],OBJPROP_XDISTANCE,(w-1)*23+92);
      ObjectSet(tfMACD[w-1],OBJPROP_YDISTANCE,110);
      ObjectSetText(tfMACD[w-1],tfMACD[w-1],6,"Verdana",TextColor);
   }

   // Valeurs de retour... pour iCustom
   SetIndexBuffer(0, retour);
   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   for(int k=1;k<tfnumber+1;k++)
      ObjectDelete("IndMACD"+k);
   for(k=1;k<tfnumber+1;k++)
      ObjectDelete(tfMACD[k-1]);
      
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   // Mise  jour de la valeur celon le TF
   retour[0] = IndVal[timeFrame];

   for(int a=1;a<tfnumber+1;a++)
      ObjectDelete("IndMACD"+a);

   for(int j=1;j<tfnumber+1;j++)
   {
      ObjectCreate("IndMACD"+j,OBJ_LABEL,0,0,0,0,0);
      ObjectSet("IndMACD"+j,OBJPROP_CORNER,Corner);
      ObjectSet("IndMACD"+j,OBJPROP_XDISTANCE,(j-1)*23+92);
      ObjectSet("IndMACD"+j,OBJPROP_YDISTANCE,120);
      ObjectSetText("IndMACD"+j,CharToStr(110),12,"Wingdings",White);
   }

   for(int x=1;x<tfnumber+1;x++)
   {
      MACDMAIN   = iMACD(NULL,tframe[x-1],fastMACD,slowMACD,signalMACD,priceMACD,MODE_MAIN,0);
      MACDSIGNAL = iMACD(NULL,tframe[x-1],fastMACD,slowMACD,signalMACD,priceMACD,MODE_SIGNAL,0);
      
      
      if (/**/ MACDMAIN > MACDSIGNAL)
      {
         IndVal[x-1]=1;
      }
      else if (/**/ MACDMAIN < MACDSIGNAL)
      {
         IndVal[x-1]=-1;
      }
      else IndVal[x-1]=0;
   }
   
   for(int y=1;y<tfnumber+1;y++)
   {
      if(IndVal[y-1]==-1) ObjectSetText("IndMACD"+y,CharToStr(110),12,"Wingdings",DownColor);
      if(IndVal[y-1]==0) ObjectSetText("IndMACD"+y,CharToStr(110),12,"Wingdings",FlatColor);
      if(IndVal[y-1]==1) ObjectSetText("IndMACD"+y,CharToStr(110),12,"Wingdings",UpColor);
   }  

   return(0);
}
